package com.hello2morrow.sonargraph.languageprovider.cplusplus.model.settings;

import static org.junit.Assert.*

import org.junit.Test

/**
 * Demonstrates how to build the --gnu_version compiler options.
 * Should be used in compiler definition templates.
 *
 * @author Ingmar
 *
 */
public class GnuVersionResolvingTest
{
    @Test
    public void test2()
    {
        String gnuVersion = null;
        List<String> lines = new ArrayList<>();
        lines.add("#define __GNUC__ 2");
        lines.add("#define __GNUC_MINOR__ 91");

        int major=0, minor=0, patch=0
        lines.each
        {
            String line = it.substring("#define ".length());
            int pos = line.indexOf(' ')

            if (pos != -1)
            {
                String name = line.substring(0, pos)
                String val =  line.substring(pos+1)

                if (!name.equals("__BLOCKS__"))
                {
                    println "-D"+name+"="+val
                    switch (name)
                    {
                        case "__GNUC__":
                            major = Integer.parseInt(val.trim())
                            break;
                        case "__GNUC_MINOR__":
                            minor = Integer.parseInt(val.trim());
                            break;
                        case "__GNUC_PATCHLEVEL__":
                            patch = Integer.parseInt(val.trim());
                            break;
                    }
                }
                else
                {
                    println "-D"+line
                }
            }
            gnuVersion = "--gnu_version=" + ((major * 10000) + (minor * 100) + patch);
            println gnuVersion;
        }

        assertEquals("--gnu_version=29100", gnuVersion);
    }
}
